<?php
/**
 * @package            Joomla
 * @subpackage         Event Booking
 * @author             sebba
 * @copyright          sebba - 2018
 * @license            GNU/GPL, see LICENSE.php
 */

// no direct access
defined('_JEXEC') or die;

class plgEventBookingAutocoupons extends JPlugin
{
	protected $table = '#__eb_autocoupons';
	public function __construct(& $subject, $config)
	{
		parent::__construct($subject, $config);
		JFactory::getLanguage()->load('plg_eventbooking_autocoupons', JPATH_ADMINISTRATOR);		
	}

	public function onEditEvent($row, $isNew)
	{
		ob_start();
		$this->drawSettingForm($row);

		return array(
			'title' => JText::_('EB_AUTOCOUPONS'),
			'form'  => ob_get_clean(),
		);
	}

	//////////////////////////////////////////////////////////////////////////////////////////////////////////
	public function onAfterSaveEvent($row, $data, $isNew)
	{
		// The plugin will only be available in the backend
		$app = JFactory::getApplication();

		// return if not in administration area
		if ($app->isSite())
		{
			return;
		}

		$db    = JFactory::getDbo();
		$query = $db->getQuery(true);
		
		//citire date din formurile de input
		$agc_ids        = $data['form_cid']; 
		$agc_parents	= $data['form_agc_parent']; 
		$agc_bindeds	= $data['form_agc_binded']; 
		$agc_val       = $data['form_agc_val'];
		$agc_type      = $data['form_agc_type'];
		$agc_times     = $data['form_agc_times'];
		$agc_until 	= $data['form_agc_until'];
		
		$agCouponsIds          = array();
		
		//resetam daca event-ul este nou ---- deocamdata e inutil, nu afisez drawSettingForm pentru eventuri nesalvate
		if ($isNew)
		{
			// Reset ID of ticket type
			for ($i = 0, $n = count($agc_ids); $i < $n; $i++)
			{
				$agc_ids[$i] = 0;
				echo "isnew".$n."<br>";
			}
		}
		
		// inserare sau modificare inregistrari in baza de date - PARENT EVENT - pentru fiecare TITLE
		for ($i = 0, $n = count($agc_ids); $i < $n; $i++)
		{
			$cid = $agc_ids[$i];

			if (empty($agc_bindeds[$i]))
			{
				continue;
			}

			$agc_parent			= (int) $agc_parents[$i];
			$agc_binded			= (int) $agc_bindeds[$i];

			$query->clear();
			
			if ($cid) //update inregistrari existente
			{
				$query->update('#__eb_autocoupons')
					->set('agc_parent = ' . $agc_parent)
					->set('agc_binded = ' . $agc_binded)
					->set('agc_val = ' . $agc_val)
					->set('agc_type = ' . $agc_type)
					->set('agc_times = ' . $agc_times)
					->set('agc_until = ' . $agc_until)
					->where('cid = ' . $cid);
			}
			else //insert inregistrari noi
			{
				$query->insert('#__eb_autocoupons')
					->columns('agc_parent, agc_binded, agc_val, agc_type, agc_times, agc_until')
					->values("$agc_parent, $agc_binded ,$agc_val, $agc_type, $agc_times, $agc_until");
			}


			$db->setQuery($query);
			$db->execute();

			if ($cid)
			{
				$agCouponsIds[] = $cid;
			}
			else
			{
				$agCouponsIds[] = $db->insertid();
			}
		}
		
		//stergere inregistrari
		if (count($agCouponsIds))
		{
			//echo "cid ptr stergere=".$cid."<br>";
			
			$query->clear()
				->delete('#__eb_autocoupons')
				->where('agc_parent = ' . $row->id)
				->where('cid NOT IN (' . implode(',', $agCouponsIds) . ')');
			$db->setQuery($query);
			$db->execute();
		}
		else
		{
			//sterge ultima inregistrare, cand count devine zero si nu se mai aplica regula de mai sus. adica se sterg toate inregistrarile eventului parinte
			$query->clear()
				->delete('#__eb_autocoupons')
				->where('agc_parent = ' . $row->id);
				//->where('cid NOT IN (' . implode(',', $agCouponsIds) . ')');
			$db->setQuery($query);
			$db->execute();
		}
	
	}
	
	///////////////////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////////////////////
	private function drawSettingForm($row)
	{
		if (empty($row->id))
		{
			echo "Available only for SAVED events. Returning!";
			return;
		}

		if ($row->parent_id > 0)
		{
			echo "Available only for PARENT events. Returning!";
			return;
		}
		//event list for dropdown selector
		//$eventslist = array();
		
		$db       = JFactory::getDbo();
		$query    = $db->getQuery(true);

		//lista pentru eventuri cu parent_id = 0
		$query->clear()
				->select('id, title')
				->from('#__eb_events')
				->where('parent_id = 0')
				->order('title');
		$db->setQuery( $query );
		$items_from_db = $db->loadObjectList();
		$eventslist[] = JHTML::_('select.option',  '0', "- Select event -", 'id', 'title' );
		$eventslist = array_merge( $eventslist, $items_from_db);

		$agCoupons = array();

		if ($row->id > 0)
		{
			$query->clear()
				->select('cid, agc_parent, agc_binded, agc_val, agc_type, agc_times, agc_until')
				->from('#__eb_autocoupons')
				->where('agc_parent = ' . (int) $row->id)
				->order('cid');
			$db->setQuery($query);
			$agCoupons = $db->loadObjectList();
		}	
		
		?>
		<br>
		<center>Enter parameters for the auto-generated coupon and set the events where the coupon will apply<br>
		<a href="https://paypal.me/interzis" target="blank">Buy me a beer!</a> - <a href=https://www.joomdonation.com/forum/events-booking-features-wish-list/60791-auto-generated-coupons.html target="blank">Forum Support Here</a><br>
		</center>
				- todo list -<br>
				- <strike>add switch button for discount type</strike>;<br>
				- add currency type autodetect;<br>
				- add link to parent (when editing a child - to move directly to the parent;<br>
				- you name it;<br>
		<hr>   
			<table align="center"><tbody><tr>
			<td>			<div><?php echo JText::_('EB_AGC_VAL').": "; ?><input type="text" class="input-mini" name="form_agc_val"
											value="<?php echo $agCoupons[0]->agc_val; ?>" />
							</div>
			</td><td>		<div class="radio btn-group ">  
								<input id="dp21" name="form_agc_type" type="radio" value="1" checked="<?php if ($agCoupons[0]->agc_type=='1') {echo 'checked'; } ?>" /> 
									<label class="btn" for="dp21">Amount (€)</label>
								<input id="dp20" name="form_agc_type" type="radio" value="0" checked="<?php if ($agCoupons[0]->agc_type=='0') {echo 'checked'; } ?>" />
									<label class="btn" for="dp20">Percent (%)</label>
							</div>
			</td><td>		<div><?php echo " ".JText::_('EB_AGC_TIMES').": "; ?><input type="text" class="input-mini" name="form_agc_times"
											value="<?php echo $agCoupons[0]->agc_times; ?>"/>
							</div>
			</td><td>		<div><?php echo " ".JText::_('EB_AGC_UNTIL').": "; ?><input type="text" class="input-mini" name="form_agc_until"
											value="<?php echo $agCoupons[0]->agc_until; ?>" />
							</div>
			</td>
			</tr></tbody></table>
				<hr>

			<div class="row-fluid">
			<div class="span51">
				<table align="center" id="adminAGCForm">
					<thead>
					<tr>
						<th class="nowrap center"><?php echo JText::_('EB_AGC_BINDED'); ?></th>
						<th class="nowrap center"><?php echo JText::_('EB_REMOVE'); ?></th>
					</tr>
					</thead>
					<tbody id="additional_agc_options">
					
					
					<?php
					$numberagCoupons = max(count($agCoupons), 1);
					for ($a = 0; $a < $numberagCoupons; $a++)
					{
						if (isset($agCoupons[$a]))
						{
							$agCoupon = $agCoupons[$a];
						}
						else
						{
							//valori in formurile de input daca nu exista inregistrari
							//$agCoupon              	= new stdClass;
							$agCoupon->cid          = '';
							$agCoupon->agc_parent   = '';
							$agCoupon->agc_binded   = '';
						}

						?>
						<tr id="opt_agc_<?php echo $a; ?>">
							<td>
								<input type="hidden" class="input-mini" name="form_cid[]" value="<?php echo $agCoupons->cid; ?>"  />
								<input type="hidden" class="input-mini" name="form_agc_parent[]"value="<?php echo $row->id; ?>"  />
								<?php echo JHtml::_('select.genericlist', $eventslist, 'form_agc_binded[]', '', 'id', 'title', $agCoupon->agc_binded); ?>
							</td>
							<td>
								<button type="button" class="btn btn-danger"
								        onclick="removeAGCContainer(<?php echo $a; ?>)"><i
										class="icon-remove"></i><?php echo JText::_('EB_REMOVE'); ?></button>
							</td>
						</tr>
						<?php
					}
					?>
					</tbody>
				</table>
				<center><button type="button" class="btn btn-success" onclick="addAGCContainer()"><i
						class="icon-new icon-white"></i><?php echo JText::_('EB_ADD'); ?></button></center>
			</div>
		</div>
		<script language="JavaScript">
			function removeAGCContainer(id) {
				if (confirm('<?php echo JText::_('EB_REMOVE_ITEM_CONFIRM'); ?>')) {
					jQuery('#opt_agc_' + id).remove();
				}
			}
			(function ($) {
				var countAGC = <?php echo $numberagCoupons; ?>;
				addAGCContainer = (function () {
					var html = '<tr id="opt_agc_' + countAGC + '">'
					html += '<td><input type="hidden" class="input-mini"name="form_cid[]" value = "" readonly /><input type="hidden" class="input-mini" name="form_agc_parent[]" value="<?php echo $row->id; ?>" readonly />';
					html += '<?php echo preg_replace(array('/\r/', '/\n/'), '', JHtml::_('select.genericlist', $eventslist, 'form_agc_binded[]', '', 'id', 'title', $agCoupon->agc_binded)); ?><!--/<input type="text" class="input-medium" name="form_agc_binded[]" value="" />--></td>';
					html += '<!--<td><input type="text" class="input-medium" name="form_agc_val[]" value="<?php echo $agCoupon->agc_val; ?>" readonly /></td>';
					html += '<td><input type="text" class="input-mini" name="form_agc_type[]" value="<?php echo $agCoupon->agc_type; ?>" readonly /></td>';
					html += '<td><input type="text" class="input-mini" name="form_agc_times[]" value="<?php echo $agCoupon->agc_times; ?>" readonly /></td>';
					html += '<td><input type="text" class="input-mini" name="form_agc_until[]" value="<?php echo $agCoupon->agc_until; ?>" readonly /></td>-->';
					html += '<td><button type="button" class="btn btn-danger" onclick="removeAGCContainer(' + countAGC + ')"><i class="icon-remove"></i><?php echo JText::_('EB_REMOVE'); ?></button></td>';
					html += '</tr>';
					$('#additional_agc_options').append(html);
					countAGC++;
				})
			})(jQuery)
		</script>
		<?php
	}
	public function onAfterPaymentSuccess($row)
	{
		if (strpos($row->payment_method, 'os_offline') == false)
		{
			$reg_code = $row->registration_code;
			$this->processAGC($row);
		}
	}

	public function onAfterStoreRegistrant($row)
	{
		if (strpos($row->payment_method, 'os_offline') != false)
		{
			$this->processAGC($row);
		}
	}
	
	/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	public function processAGC($row) {
		
		$db    = JFactory::getDbo();
		$query = $db->getQuery(true);

		$userId = $row->user_id;
		//$reg_Eid = $row->event_id;
		

		//////// parte de generare cupoane ///////////////////////////////////////////////////////////
		// extracting parent's ID for checking if this event - if child - should auto-generate coupons
		$query->clear()
			->select('parent_id')
			->from('#__eb_events')
			->where('id = ' . $row->event_id);
		$db->setQuery($query);
		$parentid = $db->loadObject();
		$Pid=$parentid->parent_id;

		$eid = $row->id;
		if ($Pid != 0) 
		{ $eid = $Pid; }

		$agCoupons = array();
		$query->clear()
			->select('cid, agc_parent, agc_binded, agc_val, agc_type, agc_times, agc_until')
			->from('#__eb_autocoupons')
			->where('agc_parent = ' . $eid);
		$db->setQuery($query);
		$agCoupons = $db->loadObjectList();
		$array = json_decode(json_encode($agCoupons), True);

		// generate random code for inserting in coupon's code
		function generateRandomString($length = 9) {
			$characters = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';
			$charactersLength = strlen($characters);
			$randomString = '';
			for ($i = 0; $i < $length; $i++) {
				$randomString .= $characters[rand(0, $charactersLength - 1)];
			}
			return $randomString;
		}		

		//if event should auto-generate coupons
		$nr_agc = count($array);
		if ($nr_agc > 0 and $userId > 0) {

			$rand_code = generateRandomString(); 
			$active_event = $row->event_id;

			//values for the auto-generated coupon (taken from the first instance)
			$agc_type 	= $array[0]['agc_type'];
			$agc_val 	= $array[0]['agc_val'];			
			$agc_total_val = $agc_val * $row->number_registrants;
			$agc_times 	= $array[0]['agc_times'];
			$agc_until = $array[0]['agc_until'];
			$agc_valid_from = date("Y-m-d H:i", time());
			$agc_valid_until = date("Y-m-d", time() + ($agc_until*86400));  //adding days for the valability of the coupon
			
			if ($agc_until < '1') {$agc_valid_until = '0';}

			$query->clear()
				->insert('#__eb_coupons')
				->columns('code, coupon_type, discount, event_id, times, used, valid_from, valid_to, published, user_id, apply_to')
				->values("'$userId$rand_code', '$agc_type', '$agc_total_val', '1', '$agc_times', '0','$agc_valid_from','$agc_valid_until','1',$userId,'1'");				
			$db->setQuery($query);
			$db->execute();

			$last_id = $db->insertid();

				//citim data de acum ca sa preluam doar eventurile viitoare
				$currentDate = $db->quote(JHtml::_('date', 'Now', 'Y-m-d'));    
				
				for ($i = 0; $i < count($array); $i++) {

						$agc_binded = $array[$i]['agc_binded'];
					
						//defining array for event's children
						$ev_child=array();
						$query->clear()
							->select('id')
							->from('#__eb_events')
							->where('parent_id = '.$agc_binded)
							->where('DATE(event_date) > '.$currentDate) 
							->order('id ASC');
						$db->setQuery($query);
						$ev_child = $db->loadObjectList();
						$ev_childs = json_decode(json_encode($ev_child), True);				

						for ($a = 0; $a < count($ev_childs); $a++) {
							$Bid= $ev_childs[$a]['id'];
							//inserare cupoane ptr fiecare event afectat
							$query->clear()
								->insert('#__eb_coupon_events')
								->columns('coupon_id, event_id')
								->values("$last_id, $Bid");				
							$db->setQuery($query);
							$db->execute();			
						}

				}

			//start sending email with AGC code
			//getting booked event's details
			$query->clear()
				->select('title, event_date, event_end_date')
				->from('#__eb_events')
				->where('id = ' . $active_event);
			$db->setQuery($query);
			$event_details = $db->loadAssoc();
		
			$user = JFactory::getUser($userId);
			$to = $user->get('email');
			$name = $user->get('name');
			$active_event_title = $event_details['title'];
			$active_event_date = $event_details['event_date'];
			$active_event_end_date = $event_details['event__end_date'];

			//extragem ID-urile eventurilor ptr care cuponul este valabil
			$query->clear()
				->select('event_id')
				->from('#__eb_coupon_events')
				->where('coupon_id = '.$last_id)
				->order('event_id ASC');

			$db->setQuery($query);
			$agc_for = $db->loadObjectList();
			$agc_for = json_decode(json_encode($agc_for), True);				

				$JDate = JFactory::getDate();
				echo $JDate;
				
				$agc_for_list = '';
				for ($i = 0; $i < count($agc_for); $i++) {
					
					$index = $agc_for[$i]['event_id'];
					$query->clear()
						->select('title, event_date')
						->from('#__eb_events')
						->where('id = ' . $index);
					$db->setQuery($query);
					$eventdetails = $db->loadAssoc();
					$active_eventtitle = $eventdetails['title'];
					$active_eventdate = $eventdetails['event_date'];
					$link 	= "https://events.end.ro/index.php?option=com_eventbooking&view=event&id=".$index;
					$agc_for_list= $agc_for_list."<a href=$link>".$active_eventtitle." - ".$active_eventdate."</a><br>";
				}

			$body = $this->params->get('agc_body');

			//formatare text ptr afisare tip discount (percent sau amount)
			if ($agc_type==0) { 
					$agcType = " %"; 
				} else { 
					$agcType = " €"; 
				}
			
			//inlocuire tags cu valoare
			$body            = str_replace("[AGC_CODE]", $userId.$rand_code, $body);
			$body            = str_replace("[AGC_VAL]", $agc_val.$agcType, $body);
			$body            = str_replace("[AGC_REGISTRANTS]", $row->number_registrants, $body);
			$body            = str_replace("[AGC_TOTAL_VAL]", $agc_total_val.$agcType, $body);
			$body            = str_replace("[AGC_VALID_UNTIL]", $agc_valid_until, $body);
			$body            = str_replace("[AGC_ACTIVE_EVENT]", $active_event, $body);
			$body            = str_replace("[NAME]", $name, $body);
			$body            = str_replace("[AGC_EVENT_TITLE]", $active_event_title, $body);
			$body            = str_replace("[AGC_EVENT_DATE]", $active_event_date, $body);
			$body            = str_replace("[AGC_EVENT_END_DATE]", $active_event_end_date, $body);
			$body            = str_replace("[AGC_VALID_FOR]", $agc_for_list, $body);

			$subject = $this->params->get('agc_subject');

			//inlocuire tags cu valoare ptr subiect
			$subject            = str_replace("[AGC_CODE]", $userId.$rand_code, $subject);
			$subject            = str_replace("[AGC_VAL]", $agc_val.$agcType, $subject);
			$subject            = str_replace("[AGC_REGISTRANTS]", $row->number_registrants, $subject);
			$subject            = str_replace("[AGC_TOTAL_VAL]", $agc_total_val.$agcType, $subject);
			$subject            = str_replace("[AGC_VALID_UNTIL]", $agc_valid_until, $subject);
			$subject            = str_replace("[AGC_ACTIVE_EVENT]", $active_event, $subject);
			$subject            = str_replace("[NAME]", $name, $subject);
			$subject            = str_replace("[AGC_EVENT_TITLE]", $active_event_title, $subject);
			$subject            = str_replace("[AGC_EVENT_DATE]", $active_event_date, $subject);
			$subject            = str_replace("[AGC_EVENT_END_DATE]", $active_event_end_date, $subject);

			# Invoke JMail Class
			$mailer = JFactory::getMailer();
			# Set sender array so that my name will show up neatly in your inbox
			$mailer->setSender(array($data['mailfrom'],$data['fromname']));
			# Add a recipient -- this can be a single address (string) or an array of addresses
			$mailer->addRecipient($to);
			$mailer->setSubject($subject);
			//	$mailer->setBody($body . $body0);
			$mailer->setBody($body);
			# If you would like to send as HTML, include this line; otherwise, leave it out
			$mailer->isHTML();
			# Send once you have set all of your options
			$mailer->send();		
			///////// finish send email
		}
		
		////////////// cand se foloseste cuponul /////////////////////////////////////////
		//stergem eventurile alocate cuponului utilizat si declaram cuponul ca nepublicat

		//daca exista cupon valid verificam daca valoarea lui este mai mare decat suma de plata
		if ($row->coupon_id)
			{
				$query->clear()
					->select($db->quoteName('discount'))
					->from('#__eb_coupons')
					->where('id = ' . $row->coupon_id);
				$db->setQuery($query);
				$data['coupon_value'] = $db->loadResult();

				$query->clear()
					->select($db->quoteName('times'))
					->from('#__eb_coupons')
					->where('id = ' . $row->coupon_id);
				$db->setQuery($query);
				$agc_type = $db->loadResult();

				$query->clear()
					->select($db->quoteName('coupon_type'))
					->from('#__eb_coupons')
					->where('id = ' . $row->coupon_id);
				$db->setQuery($query);
				$times_coupon = $db->loadResult();
				
				$coupon_value = $data['coupon_value'];	
				$order_value = $row->total_amount;
				$discount_value = $row->discount_amount;
				$diff_coupon = ($coupon_value-$discount_value);
				
			//daca valoarea cuponului este mai mare decat suma totala de plata
			//generam alt cupon pentru diferenta

			$user =& JFactory::getUser();
		
			if  ($diff_coupon > 0) 
				{
					//echo "=>> diferenta: ".$diff_coupon."<br>";
					//daca valoare cupon mai mare decat valoare order
					$user =& JFactory::getUser($userId);
					$active_event = $row->event_id;

					echo "userid = ".$user->get('id')."<br>";
					echo "diff = ".$diff_coupon."<br>";
					echo "event_id = ".$active_event."<br>";
					

					$query->clear()
						->update('#__eb_coupons')
						->set('discount = '.$diff_coupon)
						->set('times = '.($times_coupon+1))
						->where('user_id = ' . $user->get( 'id' ) )  //verificam si apartenenta cuponului pentru procesare
						->where('id = ' . $row->coupon_id);
					$db->setQuery($query);
					$db->execute();								

					/////// send email with updated coupon's data ////////////////////////////////////////
					//start sending email with AGC code
					//getting booked event's details
					$query->clear()
						->select('title, event_date, event_end_date')
						->from('#__eb_events')
						->where('id = ' . $active_event);
					$db->setQuery($query);
					$event_details = $db->loadAssoc();
				
					$user = JFactory::getUser($userId);
					$to = $user->get('email');
					$name = $user->get('name');
					$active_event_title = $event_details['title'];
					$active_event_date = $event_details['event_date'];
					$active_event_end_date = $event_details['event__end_date'];

					echo $to."<br>"; // = $user->get('email');
					echo $name."<br>"; // = $user->get('name');
					echo $active_event_title."<br>"; // = $event_details['title'];
					echo $active_event_date."<br>"; // = $event_details['event_date'];
					echo $active_event_end_date."<br>"; // = $event_details['event__end_date'];

					
					//extragem ID-urile eventurilor ptr care cuponul este valabil
					$query->clear()
						->select('event_id')
						->from('#__eb_coupon_events')
						->where('coupon_id = '.$row->coupon_id)
						->order('event_id ASC');

					$db->setQuery($query);
					$agc_for = $db->loadObjectList();
					$agc_for = json_decode(json_encode($agc_for), True);				

						$JDate = JFactory::getDate();
						echo $JDate;
						
						$agc_for_list = '';
						for ($i = 0; $i < count($agc_for); $i++) {
							
							$index = $agc_for[$i]['event_id'];
							$query->clear()
								->select('title, event_date')
								->from('#__eb_events')
								->where('id = ' . $index);
							$db->setQuery($query);
							$eventdetails = $db->loadAssoc();
							$active_eventtitle = $eventdetails['title'];
							$active_eventdate = $eventdetails['event_date'];
							$link 	= "https://events.end.ro/index.php?option=com_eventbooking&view=event&id=".$index;
							$agc_for_list= $agc_for_list."<a href=$link>".$active_eventtitle." - ".$active_eventdate."</a><br>";
						}
				//*/
					
					$body = $this->params->get('agc_regen_body');

					//formatare text ptr afisare tip discount (percent sau amount)
					if ($agc_type==0) { $agcType = " %"; } else { $agcType = " €"; }
					
					//inlocuire tags cu valoare
					$body            = str_replace("[AGC_CODE]", $userId.$rand_code, $body);
					$body            = str_replace("[AGC_VAL]", $agc_val.$agcType, $body);
					$body            = str_replace("[AGC_REGISTRANTS]", $row->number_registrants, $body);
					$body            = str_replace("[AGC_TOTAL_VAL]", $agc_total_val.$agcType, $body);
					$body            = str_replace("[AGC_NEW_VAL]", $diff_coupon.$agcType, $body);
					$body            = str_replace("[AGC_VALID_UNTIL]", $agc_valid_until, $body);
					$body            = str_replace("[AGC_ACTIVE_EVENT]", $active_event, $body);
					$body            = str_replace("[NAME]", $name, $body);
					$body            = str_replace("[AGC_EVENT_TITLE]", $active_event_title, $body);
					$body            = str_replace("[AGC_EVENT_DATE]", $active_event_date, $body);
					$body            = str_replace("[AGC_EVENT_END_DATE]", $active_event_end_date, $body);
					$body            = str_replace("[AGC_VALID_FOR]", $agc_for_list, $body);

					$subject = $this->params->get('agc_regen_subject');

					//inlocuire tags cu valoare ptr subiect
					$subject            = str_replace("[AGC_CODE]", $userId.$rand_code, $subject);
					$subject            = str_replace("[AGC_VAL]", $agc_val.$agcType, $subject);
					$subject            = str_replace("[AGC_REGISTRANTS]", $row->number_registrants, $subject);
					$subject            = str_replace("[AGC_TOTAL_VAL]", $agc_total_val.$agcType, $subject);
					$subject            = str_replace("[AGC_NEW_VAL]", $diff_coupon.$agcType, $subject);
					$subject            = str_replace("[AGC_VALID_UNTIL]", $agc_valid_until, $subject);
					$subject            = str_replace("[AGC_ACTIVE_EVENT]", $active_event, $subject);
					$subject            = str_replace("[NAME]", $name, $subject);
					$subject            = str_replace("[AGC_EVENT_TITLE]", $active_event_title, $subject);
					$subject            = str_replace("[AGC_EVENT_DATE]", $active_event_date, $subject);
					$subject            = str_replace("[AGC_EVENT_END_DATE]", $active_event_end_date, $subject);

					# Invoke JMail Class
					$mailer = JFactory::getMailer();
					# Set sender array so that my name will show up neatly in your inbox
					$mailer->setSender(array($data['mailfrom'],$data['fromname']));
					# Add a recipient -- this can be a single address (string) or an array of addresses
					$mailer->addRecipient($to);
					$mailer->setSubject($subject);
					$mailer->setBody($body);
					# If you would like to send as HTML, include this line; otherwise, leave it out
					$mailer->isHTML();
					# Send once you have set all of your options
					$mailer->send();		
					///////// finish send email
				// */
				}
				else
				{
					//$user =& JFactory::getUser();
					$query->clear()
						->delete('#__eb_coupon_events')
						->where('event_id != ' . $row->event_id)
						->where('coupon_id = ' . $row->coupon_id);
					$db->setQuery($query);
					$db->execute();			

					//unpublish used coupon
					//$user =& JFactory::getUser();
					$query->clear()
						->update('#__eb_coupons')
						->set('published = 0')
						->where('user_id = ' . $user->get( 'id' ) )  //verificam si apartenenta cuponului pentru procesare
						->where('id = ' . $row->coupon_id);
					$db->setQuery($query);
					$db->execute();			
				}			

			}
	}
	
	public function onEventDisplay($row) {

		$user =& JFactory::getUser();
		
		//daca userul este logat verificam si afisam mesaje cand are cupoane pe care le poate folosi
		if($user->get( 'id' )) {

			$db    = JFactory::getDbo();
			$query = $db->getQuery(true);		

			//numarul de cupoane disponibile ptr userul logat
			$cupoane = array();

			$query->clear()
				->select('user_id, id, code, discount, coupon_type, valid_to')
				->from('#__eb_coupons')
				->where('user_id = ' . $user->get( 'id' ) )
			//	->where('used = "0"')
				->where('published = 1');
			$db->setQuery($query);
			$cupoane = $db->loadObjectList();
			$cupoane = json_decode(json_encode($cupoane), True);				
			$agcnr = count($cupoane);

			foreach ($cupoane as $value){ 
			//echo "id=".$value[id]."<br>";  	
			//echo "code=".$value[code]."<br>";  	
			//echo "event=".$row->id."<br>";  	
			//$coduri = array();

				$query->clear()
					->select('COUNT(*)')
					->from('#__eb_coupon_events')
					->where('coupon_id = ' . $value[id] )
					->where('event_id = ' . $row->id );
				$db->setQuery($query);
				$count = $db->loadResult();
				if ($count > 0) {
					$coduri = $value[code]; 
					JFactory::getApplication()->enqueueMessage('Coupon code available: <b>'.$coduri.'</b> - Discount: <b>'.$value[discount].' €</b> - Valid until: <b>'.$value[valid_to].'</b>', 'notice');
					}
			}
		}
	}
}
